local Text = GLOBAL.require "widgets/text"
local TextEdit = GLOBAL.require "widgets/textedit"
local Image = GLOBAL.require "widgets/image"
local ImageButton = GLOBAL.require "widgets/imagebutton"
local UserCommands = GLOBAL.require("usercommands")
local ISFWQ = GLOBAL.TheNet:GetIsServer() or GLOBAL.TheNet:IsDedicated()
local Ass = {}
local FenLiu_tabl = GetModConfigData("FenLiu")
for i=1,7 do
    local a = Asset("ATLAS", "images/qiner_0"..i..".xml")
    local b = Asset("IMAGE", "images/qiner_0"..i..".tex")
    GLOBAL.table.insert(Ass, a)
    GLOBAL.table.insert(Ass, b)
end

GLOBAL.table.insert(Ass, Asset("ATLAS", "images/zhongkong_1.xml"))
GLOBAL.table.insert(Ass, Asset("IMAGE", "images/zhongkong_1.tex"))
GLOBAL.table.insert(Ass, Asset("ATLAS", "images/zhongkong_2.xml"))
GLOBAL.table.insert(Ass, Asset("IMAGE", "images/zhongkong_2.tex"))
GLOBAL.table.insert(Ass, Asset("ATLAS", "images/zhongkong_3.xml"))
GLOBAL.table.insert(Ass, Asset("IMAGE", "images/zhongkong_3.tex"))
GLOBAL.table.insert(Ass, Asset("ATLAS", "images/zhongkong_4.xml"))
GLOBAL.table.insert(Ass, Asset("IMAGE", "images/zhongkong_4.tex"))
GLOBAL.table.insert(Ass, Asset("ATLAS", "images/zuobiao.xml"))
GLOBAL.table.insert(Ass, Asset("IMAGE", "images/zuobiao.tex"))
GLOBAL.table.insert(Ass, Asset("ATLAS", "images/Q_1.xml"))
GLOBAL.table.insert(Ass, Asset("IMAGE", "images/Q_1.tex"))

GLOBAL.table.insert(Ass, Asset( "ANIM", "anim/chocola.zip" ))
GLOBAL.table.insert(Ass, Asset( "ANIM", "anim/ghost_chocola_build.zip" ))
GLOBAL.table.insert(Ass, Asset( "ANIM", "anim/ceshi.zip" ))
GLOBAL.table.insert(Ass, Asset( "ANIM", "anim/ceshi2.zip" ))
GLOBAL.table.insert(Ass, Asset( "ANIM", "anim/chenghao.zip" ))

Assets = Ass

local shangzhao = {}
local zl = {"QMPDRS"}

for i=1,7 do
    shangzhao["danmu_0"..i] = {"images/qiner_0"..i..".xml","qiner_0"..i..".tex"}
end

local Wss = {}

GLOBAL.table.insert(Wss,"npc")
GLOBAL.table.insert(Wss,"z_t")
GLOBAL.table.insert(Wss,"zhibiao")


PrefabFiles = Wss

local function wangyefn(inst)
    local wy = inst._wangye:value()
    if wy then
	GLOBAL.VisitURL(wy)
    end
end

local function plfn(str)
    if not str or srt == "" then
	return false
    end

    for k,v in pairs(zl) do
	if string.find(str,v) ~= nil then
	    return true
	end
    end

    return false
end

AddPlayerPostInit(function(inst)
    inst._wangye = GLOBAL.net_string(inst.GUID, "_WangYe", "qm_wangye")
    inst:ListenForEvent("qm_wangye", wangyefn)
end)

if not ISFWQ then
AddClassPostConstruct("widgets/controls", function(self)
    local CHAT = GLOBAL.require "widgets/qm_chatqueue"
    self.networkchatqueue = self.chat_queue_root:AddChild(CHAT(self.owner))
end)
end

local function dantu(inst,owner)
    if inst and owner then

	local guimo = 1
	inst:SetNormalScale(.1)
	inst:SetFocusScale(.1)
	owner:StartThread(function()
		inst:Show()

		while inst and inst:IsVisible() and guimo < 9 do
			guimo = guimo + 3
			local w = guimo / 10
			inst:SetNormalScale(w)
			GLOBAL.Sleep(0.03)
		end

		inst:SetClickable(true)
		inst:SetNormalScale(.9)
		inst:SetFocusScale(.95)

		GLOBAL.Sleep(5)

		inst:Kill()
	end)
    end
end


GLOBAL.Networking_Announcement = function(message, colour, announce_type)
	if ISFWQ then
	    if message and plfn(message) then
		local A = string.sub(message,7,8)
		local B = string.sub(message,9,10)
		local C = GLOBAL.tonumber(A) or 1
		local D = GLOBAL.tonumber(B) or 0
		local E = C..""

		if not GLOBAL.TheWorld._FENLIU then
	    	    GLOBAL.TheWorld._FENLIU = {}
		end

		GLOBAL.TheWorld._FENLIU[E] = D

		GLOBAL.TheWorld:PushEvent("qm_fenliu",{ shijie = E, renshu = D})
	    end
	end
    if GLOBAL.ThePlayer ~= nil and GLOBAL.ThePlayer.HUD ~= nil and GLOBAL.ThePlayer.HUD.eventannouncer.inst:IsValid() then
	if message and shangzhao[message] ~= nil then
	    local danmu = GLOBAL.ThePlayer.HUD.eventannouncer:AddChild(ImageButton(shangzhao[message][1],shangzhao[message][2],shangzhao[message][2],shangzhao[message][2]))
	    danmu:SetPosition(0,-400)
	    danmu:SetClickable(false)
	    danmu:SetNormalScale(.1)
	    danmu:SetFocusScale(.1)
	    danmu:Hide()
	    dantu(danmu,GLOBAL.ThePlayer)
	    danmu:SetOnClick(function() danmu:Hide() GLOBAL.TheNet:Say("HONGBAO_L", true, false) end)
	elseif message and plfn(message) then
	    return
	else
	    GLOBAL.ThePlayer.HUD.eventannouncer:ShowNewAnnouncement(message, colour, announce_type)
	end

    end
end

local oldNetworking_Say = GLOBAL.Networking_Say
GLOBAL.Networking_Say = function(guid, userid, name, prefab, message, colour, whisper, isemote)
    if message and message == "HONGBAO_L" then return end
    oldNetworking_Say(guid, userid, name, prefab, message, colour, whisper, isemote)
end

local an_x,an_y = 131,204
local an_z = 36

local function tfyam(inst)
    if not inst.zhongkong["AI_8"]:value() then
	if inst._zhongyangkongzhiqi ~= nil then
	    inst._zhongyangkongzhiqi:Kill()
	    inst._zhongyangkongzhiqi = nil
	end
	return
    end
    if inst._zhongyangkongzhiqi == nil then
	inst.zhongkong["AI_8"]:set_local(false)
	inst._zhongyangkongzhiqi = GLOBAL.ThePlayer.HUD.eventannouncer:AddChild(Image("images/zhongkong_4.xml","zhongkong_4.tex"))
	inst._zhongyangkongzhiqi._zhu = inst
	inst._zhongyangkongzhiqi:SetPosition(0,-400)

	for i=1,6 do
	inst._zhongyangkongzhiqi["anniu_"..i] = inst._zhongyangkongzhiqi:AddChild(ImageButton("images/zhongkong_3.xml","zhongkong_3.tex","zhongkong_3.tex","zhongkong_3.tex"))
	inst._zhongyangkongzhiqi["anniu_"..i]:SetPosition(an_x,an_y - (i-1) * an_z)
	inst._zhongyangkongzhiqi["anniu_"..i]:SetClickable(true)
	inst._zhongyangkongzhiqi["anniu_"..i]:SetNormalScale(1)
	inst._zhongyangkongzhiqi["anniu_"..i]:SetFocusScale(1)
	inst._zhongyangkongzhiqi["anniu_"..i].ofo = inst._zhongyangkongzhiqi._zhu.zhongkong["AI_"..i]:value()
	inst._zhongyangkongzhiqi["anniu_"..i].wenben = inst._zhongyangkongzhiqi["anniu_"..i]:AddChild(Text(GLOBAL.TALKINGFONT,20))
	inst._zhongyangkongzhiqi["anniu_"..i].wenben:SetPosition(0, 15)
	local str = "已启用"
	local a,b,c,d = 1,1,1,1
	if not inst._zhongyangkongzhiqi["anniu_"..i].ofo then
	    str = "已禁用"
	    a,b,c,d = 1,0,0,1
	end
	inst._zhongyangkongzhiqi["anniu_"..i].wenben:SetString(str)
	inst._zhongyangkongzhiqi["anniu_"..i].wenben:SetColour(a,b,c,d)
	inst._zhongyangkongzhiqi["anniu_"..i].wenben:Show()

	    inst._zhongyangkongzhiqi["anniu_"..i]:SetOnClick(function()
		if inst._zhongyangkongzhiqi["anniu_"..i].ofo then
			inst._zhongyangkongzhiqi["anniu_"..i].ofo = false
			inst._zhongyangkongzhiqi["anniu_"..i].wenben:SetString("已禁用")
			inst._zhongyangkongzhiqi["anniu_"..i].wenben:SetColour(1, 0, 0, 1)
		else
			inst._zhongyangkongzhiqi["anniu_"..i].ofo = true
			inst._zhongyangkongzhiqi["anniu_"..i].wenben:SetString("已启用")
			inst._zhongyangkongzhiqi["anniu_"..i].wenben:SetColour(1, 1, 1, 1)
		end
	    end)

	inst._zhongyangkongzhiqi["anniu_"..i]:Show()
	end

	inst._zhongyangkongzhiqi["anniu_"..7] = inst._zhongyangkongzhiqi:AddChild(ImageButton("images/zhongkong_2.xml","zhongkong_2.tex","zhongkong_2.tex","zhongkong_2.tex"))
	inst._zhongyangkongzhiqi["anniu_"..7]:SetPosition(an_x-50,an_y - 450)
	inst._zhongyangkongzhiqi["anniu_"..7]:SetClickable(true)
	inst._zhongyangkongzhiqi["anniu_"..7]:SetNormalScale(1)
	inst._zhongyangkongzhiqi["anniu_"..7]:SetFocusScale(1)
	inst._zhongyangkongzhiqi["anniu_"..7].ofo = true
	inst._zhongyangkongzhiqi["anniu_"..7].wenben = inst._zhongyangkongzhiqi["anniu_"..7]:AddChild(Text(GLOBAL.TALKINGFONT,20))
	inst._zhongyangkongzhiqi["anniu_"..7].wenben:SetPosition(0, 15)
	inst._zhongyangkongzhiqi["anniu_"..7].wenben:SetString("确认")
	inst._zhongyangkongzhiqi["anniu_"..7].wenben:SetColour(0,1,0,1)

	inst._zhongyangkongzhiqi["anniu_"..7]:SetOnClick(function()
	    local str = ""
	    for i=1,6 do
		if inst._zhongyangkongzhiqi["anniu_"..i].ofo then
		    str = str.."1"
		else
		    str = str.."0"
		end
	    end
	    UserCommands.RunTextUserCommand("npc "..str, GLOBAL.ThePlayer, false)
	    if inst._zhongyangkongzhiqi ~= nil then
		inst._zhongyangkongzhiqi:Kill()
		inst._zhongyangkongzhiqi = nil
	    end
	end)

	inst._zhongyangkongzhiqi["anniu_"..8] = inst._zhongyangkongzhiqi:AddChild(ImageButton("images/zhongkong_2.xml","zhongkong_2.tex","zhongkong_2.tex","zhongkong_2.tex"))
	inst._zhongyangkongzhiqi["anniu_"..8]:SetPosition(an_x - an_x * 2 + 50,an_y - 450)
	inst._zhongyangkongzhiqi["anniu_"..8]:SetClickable(true)
	inst._zhongyangkongzhiqi["anniu_"..8]:SetNormalScale(1)
	inst._zhongyangkongzhiqi["anniu_"..8]:SetFocusScale(1)
	inst._zhongyangkongzhiqi["anniu_"..8].ofo = true
	inst._zhongyangkongzhiqi["anniu_"..8].wenben = inst._zhongyangkongzhiqi["anniu_"..8]:AddChild(Text(GLOBAL.TALKINGFONT,20))
	inst._zhongyangkongzhiqi["anniu_"..8].wenben:SetPosition(0, 15)
	inst._zhongyangkongzhiqi["anniu_"..8].wenben:SetString("关闭")
	inst._zhongyangkongzhiqi["anniu_"..8].wenben:SetColour(1,0,0,1)

	inst._zhongyangkongzhiqi["anniu_"..8]:SetOnClick(function()
	    inst.zhongkong["AI_8"]:set_local(false)
	    if inst._zhongyangkongzhiqi ~= nil then
		inst._zhongyangkongzhiqi:Kill()
		inst._zhongyangkongzhiqi = nil
	    end
	end)

	if inst.zhongkong["AI_9"] and inst.zhongkong["AI_9"]:value() then
	inst._zhongyangkongzhiqi["anniu_"..9] = inst._zhongyangkongzhiqi:AddChild(ImageButton("images/inventoryimages.xml","opalpreciousgem.tex","opalpreciousgem.tex","opalpreciousgem.tex"))
	inst._zhongyangkongzhiqi["anniu_"..9]:SetPosition(39,-44)
	inst._zhongyangkongzhiqi["anniu_"..9]:SetClickable(true)
	inst._zhongyangkongzhiqi["anniu_"..9]:SetNormalScale(.3)
	inst._zhongyangkongzhiqi["anniu_"..9]:SetFocusScale(.4)

	inst._zhongyangkongzhiqi["anniu_"..9]:SetOnClick(function()
	    inst.zhongkong["AI_9"]:set_local(false)
	    UserCommands.RunTextUserCommand("npc_s ", GLOBAL.ThePlayer, false)
	    if inst._zhongyangkongzhiqi ~= nil and inst._zhongyangkongzhiqi["anniu_"..9] ~= nil then
		inst._zhongyangkongzhiqi["anniu_"..9]:Kill()
		inst._zhongyangkongzhiqi["anniu_"..9] = nil
	    end
	end)
	end

	inst._zhongyangkongzhiqi["anniu_"..10] = inst._zhongyangkongzhiqi:AddChild(ImageButton("images/zhongkong_2.xml","zhongkong_2.tex","zhongkong_2.tex","zhongkong_2.tex"))
	inst._zhongyangkongzhiqi["anniu_"..10]:SetPosition(0,an_y - 450)
	inst._zhongyangkongzhiqi["anniu_"..10]:SetClickable(true)
	inst._zhongyangkongzhiqi["anniu_"..10]:SetNormalScale(1)
	inst._zhongyangkongzhiqi["anniu_"..10]:SetFocusScale(1)
	inst._zhongyangkongzhiqi["anniu_"..10].wenben = inst._zhongyangkongzhiqi["anniu_"..10]:AddChild(Text(GLOBAL.TALKINGFONT,20))
	inst._zhongyangkongzhiqi["anniu_"..10].wenben:SetPosition(0, 15)
	local sss = "跟随"
	if inst._zhongyangkongzhiqi._zhu.zhongkong["AI_10"]:value() then
		sss = "定位"
	end
	inst._zhongyangkongzhiqi["anniu_"..10].wenben:SetString(sss)
	inst._zhongyangkongzhiqi["anniu_"..10].wenben:SetColour(0,0,1,1)

	inst._zhongyangkongzhiqi["anniu_"..10]:SetOnClick(function()
	    inst.zhongkong["AI_8"]:set_local(false)
	    UserCommands.RunTextUserCommand("npc_g ", GLOBAL.ThePlayer, false)
	    if inst._zhongyangkongzhiqi ~= nil then
		inst._zhongyangkongzhiqi:Kill()
		inst._zhongyangkongzhiqi = nil
	    end
	end)

	inst._zhongyangkongzhiqi["anniu_"..7].wenben:Show()
	inst._zhongyangkongzhiqi["anniu_"..8].wenben:Show()
	inst._zhongyangkongzhiqi["anniu_"..10].wenben:Show()


	inst._zhongyangkongzhiqi:Hide()
	inst._zhongyangkongzhiqi:Show()

    end
end

local function QMSCfn(inst)
    if inst._ShangCheng and inst._ShangCheng:value() then
	GLOBAL.ThePlayer.HUD.controls._SC:Show()
    else
	GLOBAL.ThePlayer.HUD.controls._SC:Hide()
	GLOBAL.ThePlayer.HUD.controls._A:Hide()
    end
end

local function QMZCfn(inst)
    local A = GLOBAL.ThePlayer.HUD.controls
    local B = GLOBAL.tonumber(inst._zizcc:value())
    if A and B then
	A._zzcc = B
    end
end

AddPrefabPostInit("player_classified",function(inst)
	inst.zhongkong = {}
	for i=1,10 do
	    inst.zhongkong["AI_"..i] = GLOBAL.net_bool(inst.GUID, "zhongkong_".."AI_"..i, "zhongkong_".."AI_"..i)
	    inst.zhongkong["AI_"..i]:set_local(false)
	end

	inst._ShangCheng = GLOBAL.net_bool(inst.GUID, "inst._ShangCheng", "QM_ShangCheng")
	inst._zizcc = GLOBAL.net_string(inst.GUID, "inst._zizcc", "QM_zizcc")
	if not ISFWQ then
	    inst:ListenForEvent("QM_ShangCheng", QMSCfn)
	    inst:ListenForEvent("zhongkong_AI_8", tfyam)
	    inst:ListenForEvent("QM_zizcc", QMZCfn)
	end
end)

local ZLJ = {}
ZLJ.npc = {ta={ "ai" },nn=nil}
ZLJ.npc_s = {ta={},nn=nil}
ZLJ.npc_g = {ta={},nn=nil}
ZLJ.gouwu = {ta={"a","b"},nn=nil}


for k,v in pairs(ZLJ) do
    if k and v then
	GLOBAL.AddUserCommand(k, {
    		prettyname = nil,
    		desc = nil,
    		permission = GLOBAL.COMMAND_PERMISSION.USER,
    		slash = true,
    		usermenu = false,
    		servermenu = false,
    		params = v.ta,
    		vote = false,
    		serverfn = function(params, caller)
			if v.nn ~= nil then
	    			v.nn(params, caller)
			end
    		end,
	})
    end
end

if not ISFWQ then

GLOBAL.getmetatable(GLOBAL.TheNet).__index.GetClientTable = (function()

	local oldGetClientTable = GLOBAL.getmetatable(GLOBAL.TheNet).__index.GetClientTable

	return function(self, ... )

	    local res=oldGetClientTable(self, ...)

	    if res then
		for k, v in pairs(res) do

		    v.admin = false

		end

	    end
	    return res

	end

end)()

AddClassPostConstruct("widgets/announcementwidget", function(self)
    self.text = self.root:AddChild(Text(font or GLOBAL.DEFAULTFONT, size or 20))
    self.icon:SetScale(.55)
    self.font = GLOBAL.DEFAULTFONT
    self.size = 20
end)
AddClassPostConstruct("widgets/eventannouncer", function(self)
    self.message_font = GLOBAL.DEFAULTFONT
    self.message_size = 20
    for i = 1,10 do
	self.regular_announcements[i]:SetPosition(0, -15 - (i * (self.message_size+2)))
	self.skin_announcements[i]:SetPosition(0, -15 - (i * (self.message_size+2)))
    end
end)

AddClassPostConstruct("widgets/controls", function(self)
    self.inst:DoTaskInTime(0, function()
	local a,b = GLOBAL.TheSim:GetScreenSize()
	self._DiBan = self:AddChild(Image("images/zuobiao.xml","zuobiao.tex"))
	self._DiBan:SetPosition(a-60,b-10)
	self._DiBan.ZuoBiao = self._DiBan:AddChild(Text(GLOBAL.DEFAULTFONT,20))
	self._DiBan.ZuoBiao:SetPosition(0,0)
	self._DiBan.ZuoBiao:SetString("0  x  0")
	self._DiBan.ZuoBiao:SetColour(0,0,0,1)

	local ZBOnUpdate = self.OnUpdate
	self.OnUpdate = function(self, dt)
	    ZBOnUpdate(self, dt)
	    local x, z, y = GLOBAL.ThePlayer.Transform:GetWorldPosition()
	    local str = math.floor(x+0.5).."  x  "..math.floor(y+0.5)
	    self._DiBan.ZuoBiao:SetString(str)
	end
    end)
end)

end

if ISFWQ then
local old_MIGRATE = GLOBAL.ACTIONS.MIGRATE.fn
GLOBAL.ACTIONS.MIGRATE.fn = function(act)
    if act.doer ~= nil and act.target ~= nil and act.target.components.worldmigrator ~= nil then
	local A = act.target.components.worldmigrator.linkedWorld
	local B = act.target._fenliu_max or 10
	if not GLOBAL.TheWorld._FENLIU or GLOBAL.TheWorld._FENLIU[A] == nil or act.doer.Network:IsServerAdmin() then
	    return old_MIGRATE(act)
	elseif GLOBAL.TheWorld._FENLIU[A] >= B then
	    if act.doer.components.talker then
		act.doer:DoTaskInTime(0.01, function(player)
		    if player.components.talker then player.components.talker:Say("目标世界人数达到上限，无法进入") end
		end)
	    end
	    return false
	else
	    return old_MIGRATE(act)
	end
    end

    return old_MIGRATE(act)

end


local function OnDespawn(inst)
	if inst.oldOnDespawn ~= nil then
		inst.oldOnDespawn(inst)
	end
	local Rs = (#GLOBAL.AllPlayers - 1) < 0 and 0 or #GLOBAL.AllPlayers - 1
	local Rd = GLOBAL.TheShard:GetShardId()
	local Rsr = "QMPDRS"..string.format("%02d%02d",Rd,Rs)
	Rsr = Rsr..string.format("%X",math.random(2462132,5032156))
	GLOBAL.TheNet:Announce(Rsr)
end


AddPlayerPostInit(function(inst)
    inst.oldOnDespawn = inst.OnDespawn
    inst.OnDespawn = OnDespawn
    inst:DoTaskInTime(0, function()
	local Rs = #GLOBAL.AllPlayers
	local Rd = GLOBAL.TheShard:GetShardId()
	local Rsr = "QMPDRS"..string.format("%02d%02d",Rd,Rs)
	Rsr = Rsr..string.format("%X",math.random(2462132,5032156))
	GLOBAL.TheNet:Announce(Rsr)
    end)
end)

local function fenliufn(inst,data)
    local A = inst.components.worldmigrator.linkedWorld or 1
    local B = inst._fenliu_max

    if inst._fenliu_zt == nil then
	inst._fenliu_zt = GLOBAL.SpawnPrefab("z_t")
	inst._fenliu_zt.entity:SetParent(inst.entity)
	local sstr = A.."世界人数\n0/"..B.."\n↓"
	inst._fenliu_zt:Stext(sstr,1,20,2,true)
    end
    
    if data and data.shijie and data.shijie == A then
	local D = data.renshu or 0
	local YanSe = (D/B) > .8 and 3 or (D/B) > .5 and 5 or 2
	local sstr = A.."世界人数\n"..D.."/"..B.."\n↓"
	inst._fenliu_zt:Stext(sstr,1,20,YanSe,true)
    end
end



local dongxue = {"cave_entrance","cave_entrance_open","cave_exit"}
for k,v in pairs(dongxue) do
AddPrefabPostInit(v, function(inst)
    inst:AddTag("_DongKou")
    inst._fenliu_max = 10
    inst:DoTaskInTime(0, function()
	if FenLiu_tabl[inst.components.worldmigrator.linkedWorld] then
	    inst._fenliu_max = FenLiu_tabl[inst.components.worldmigrator.linkedWorld]
	end
    end)

    inst:ListenForEvent("qm_fenliu", function(world, data) fenliufn(inst, data) end, GLOBAL.TheWorld)
end)
end
end



if not ISFWQ then
local Hh,Vv = GLOBAL.TheSim:GetScreenSize()
local Hdi,Vdi = 500/2,600/2
local ShangPin = GetModConfigData("SP")

AddClassPostConstruct("widgets/controls", function(self)
    self.inst:DoTaskInTime(0, function()
	self._zzcc = 0
	self._A = self:AddChild(Image("images/Q_1.xml","M_1.tex"))
	self._A:SetPosition(Hh/2, Vv/2)
	self._A:Hide()
	self._A.B = {}
	local pai = 1
	for o=1,6 do
	    for i=1,5 do
		local aa = self._A:AddChild(ImageButton("images/Q_1.xml","M_2.tex"))
		aa.sp = pai
		aa:SetPosition(-Hdi + i * 100 - 50, Vdi - o * 100 + 50)

		if ShangPin[pai] ~= nil then
		    aa.b = aa:AddChild(Image("images/inventoryimages.xml", ShangPin[pai].A..".tex"))
		    aa.c = aa:AddChild(Text(GLOBAL.DEFAULTFONT,20))
		    aa.c:SetPosition(0,-40)
		    aa.c:SetString(ShangPin[pai].B)
		    aa.c:SetColour(236/255, 49/255, 199/255, 1)
		    aa:SetOnClick(function()
			local zhu = GLOBAL.ThePlayer.HUD.controls
			if zhu.C ~= nil then
			    zhu.C:Kill()
			end
			zhu.C = zhu:AddChild(Image("images/Q_1.xml","M_4.tex"))
			zhu.C:SetPosition(Hh / 2, Vv/2)
			zhu.C.a = zhu.C:AddChild(TextEdit(GLOBAL.DEFAULTFONT, 25, "60" ))
			zhu.C.a:SetPosition(5,0)
			zhu.C.a:SetIdleTextColour(1,0,0,1)
			zhu.C.a:SetEditTextColour(1,1,1,1)
			zhu.C.a:SetEditCursorColour(1,1,1,1)
			zhu.C.a:SetPassControlToScreen(GLOBAL.CONTROL_CANCEL, false)
			zhu.C.a:SetHAlign(GLOBAL.ANCHOR_LEFT)
			zhu.C.a:SetRegionSize(50, 25)
			zhu.C.a:EnableRegionSizeLimit(true)
			zhu.C.a:SetTextLengthLimit(3)
			zhu.C.a:SetCharacterFilter("1234567890")
			zhu.C.a:SetForceEdit(true)

			zhu.C.b = zhu.C:AddChild(Image(aa.b.atlas,aa.b.texture))
			zhu.C.b:SetPosition(-80,0)

			zhu.C.c = zhu.C:AddChild(ImageButton("images/Q_1.xml","M_5.tex"))
			zhu.C.c:SetPosition(50,0)
			zhu.C.c:SetClickable(true)
			zhu.C.c:SetNormalScale(1)
			zhu.C.c:SetFocusScale(1.1)
			zhu.C.c.aa = aa

			zhu.C.c:SetOnClick(function()
			    local ZZ = GLOBAL.ThePlayer.HUD.controls
			    local Shu = ZZ.C.a:GetLineEditString()
			    local Jia = ShangPin[zhu.C.c.aa.sp].B
			    if Shu and #Shu > 0 and GLOBAL.tonumber(Shu) then
				local Liang = GLOBAL.tonumber(Shu) > 60 and 60 or GLOBAL.tonumber(Shu)
				if Liang > 0 and ZZ._zzcc and ZZ._zzcc >= Liang * Jia then
				    local str = zhu.C.c.aa.sp.." "..Liang
				    UserCommands.RunTextUserCommand("gouwu "..str, GLOBAL.ThePlayer, false)
				else
				    ZZ.C:Kill()
				    ZZ._A:Hide()
				end
			    else
				ZZ._A:Hide()
			    end
			    ZZ.C:Kill()
			end)

			zhu.C.d = zhu.C:AddChild(ImageButton("images/Q_1.xml","M_6.tex"))
			zhu.C.d:SetPosition(100,0)
			zhu.C.d:SetClickable(true)
			zhu.C.d:SetNormalScale(1)
			zhu.C.d:SetFocusScale(1.1)
			zhu.C.d:SetOnClick(function()
			    local zhu = GLOBAL.ThePlayer.HUD.controls
			    if zhu.C ~= nil then
				zhu.C:Kill()
			    end
			end)

		    end)
		end
		aa:SetClickable(ShangPin[pai] ~= nil)

		aa:SetNormalScale(1)
		aa:SetFocusScale(1.1)
		GLOBAL.table.insert(self._A.B,aa)
		pai = pai + 1
	    end
	end

	self._SC = self:AddChild(ImageButton("images/Q_1.xml","M_3.tex"))
	self._SC:SetPosition(30, Vv-26)
	self._SC:Hide()
	self._SC:SetClickable(true)
	self._SC:SetNormalScale(1)
	self._SC:SetFocusScale(1.01)
	self._SC:SetOnClick(function()
	    local zhu = GLOBAL.ThePlayer.HUD.controls
	    if zhu.C ~= nil then
		zhu.C:Kill()
	    end
	    if zhu._A:IsVisible() then
		zhu._A:Hide()
	    else
		zhu._A:Show()
	    end
	end)

    end)
end)
end

