local assets =
{
	Asset( "ANIM", "anim/chocola.zip" ),
	Asset( "ANIM", "anim/ghost_chocola_build.zip" ),
}

local function fn()
        local inst = CreateEntity()
        inst.entity:AddTransform()
        inst.entity:AddAnimState()
        inst.entity:AddNetwork()

	MakeGhostPhysics(inst, 1, 0.5)
	inst.Transform:SetFourFaced(inst)

        inst.AnimState:SetBank("wilson")
        inst.AnimState:SetBuild("chocola")
	inst.AnimState:PlayAnimation("idle")

        inst.entity:SetPristine()

        if not TheWorld.ismastersim then
            return inst
        end

	return inst
end

local NPC_L = {}
for i=1,10 do
    table.insert(NPC_L, Prefab("npc_"..i, fn))
end

return unpack(NPC_L)